<?php 
/*
Plugin Name: admin_ws_api
Version: auto
Description: This plugin provides the functionality to administrate users and groups using the web services api.
Plugin URI: auto
Author: chrisa
Author URI: 
*/

/**
 * This is the main file of the plugin, called by Piwigo in "include/common.inc.php" line 137.
 * At this point in the code, Piwigo is not completely initialized, so nothing should be done directly
 * except define constants and event handlers (see http://piwigo.org/doc/doku.php?id=dev:plugins)
 */

defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');

global $prefixeTable;

// +-----------------------------------------------------------------------+
// | Define plugin constants                                               |
// +-----------------------------------------------------------------------+
defined('ADMIN_WS_API_ID') or define('ADMIN_WS_API_ID', basename(dirname(__FILE__)));
define('ADMIN_WS_API_PATH' ,   PHPWG_PLUGINS_PATH . ADMIN_WS_API_ID . '/');
define('ADMIN_WS_API_ADMIN',   get_root_url() . 'admin.php?page=plugin-' . ADMIN_WS_API_ID);
define('ADMIN_WS_API_VERSION', 'auto');
// this is automatically updated by PEM if you publish your plugin with SVN, otherwise you 
// must remember to change it, as well as "Version" in the plugin header


// +-----------------------------------------------------------------------+
// | Add event handlers                                                    |
// +-----------------------------------------------------------------------+
// init the plugin
add_event_handler('init', 'admin_ws_api_init');

// add API function
add_event_handler('ws_add_methods', 'admin_ws_api_ws_add_methods');


// files containing specific plugin functions
include_once(ADMIN_WS_API_PATH . 'include/functions.inc.php');
include_once(ADMIN_WS_API_PATH . 'include/ws_functions.inc.php');



/**
 * plugin initialization
 *   - check for upgrades
 *   - unserialize configuration
 *   - load language
 */
function admin_ws_api_init()
{
  global $conf, $pwg_loaded_plugins;
  
  // apply upgrade if needed
  if (
    ADMIN_WS_API_VERSION == 'auto' or
    $pwg_loaded_plugins[ADMIN_WS_API_ID]['version'] == 'auto' or
    version_compare($pwg_loaded_plugins[ADMIN_WS_API_ID]['version'], ADMIN_WS_API_VERSION, '<')
  )
  {
    // call install function
    include_once(ADMIN_WS_API_PATH . 'include/install.inc.php');
    admin_ws_api_install();
    
    // update plugin version in database
    if ( $pwg_loaded_plugins[ADMIN_WS_API_ID]['version'] != 'auto' and ADMIN_WS_API_VERSION != 'auto' )
    {
      $query = '
UPDATE '. PLUGINS_TABLE .'
SET version = "'. ADMIN_WS_API_VERSION .'"
WHERE id = "'. ADMIN_WS_API_ID .'"';
      pwg_query($query);
      
      $pwg_loaded_plugins[ADMIN_WS_API_ID]['version'] = ADMIN_WS_API_VERSION;
      
      if (defined('IN_ADMIN'))
      {
        $_SESSION['page_infos'][] = 'Admin_ws_api updated to version '. ADMIN_WS_API_VERSION;
      }
    }
  }

  if (defined('IN_ADMIN'))
  { 
  }
  else
  {
    // add a public section
  }

  // load plugin language file
  load_language('plugin.lang', ADMIN_WS_API_PATH);
}
?>